<script lang="ts">
  import { Card, CardBody, Col, Row } from '@sveltestrap/sveltestrap';
  import { Gql } from '@db';
  import { eventId, keycloak, team } from '@stores';
  import { EventRole } from '@auth/models';
  import { faFlag } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';

  let summary: CtfSummary[] = [];
  team.subscribe((team) => {
    Gql.subscribeSimple<{ scoreboard_challenge_solves_by_category: CtfSummary[] }>(
      `subscription ${activeSolvesQuery($eventId, team?.id!)}`,
      (data) => (summary = data.scoreboard_challenge_solves_by_category),
      { queryRole: $keycloak.getFirstRole([EventRole.Staff, EventRole.Participant]) },
    );
  });

  type CtfSummary = {
    category: string;
    solved: number;
    total: number;
  };

  function activeSolvesQuery(eventId: string, teamId: string) {
    return `ChallengeActiveVSolves {
      scoreboard_challenge_solves_by_category (
        where: {
          event_id: {_eq: ${JSON.stringify(eventId)}},
          team_id: {_eq: ${JSON.stringify(teamId)}},
        },
        order_by: {category: asc}
      ) {
        category
        solved
        total
      }
    }`;
  }
</script>

<div class="container-fluid">
  {#if summary.length > 0}
    <div class="row justify-content-around row-cols-1 row-cols-lg-2 row-cols-xxl-3">
      {#each summary as obj}
        <div class="col p-2">
          <Card class={obj.solved === obj.total ? 'negate' : ''}>
            <CardBody>
              <Row>
                <Col>
                  <Fa icon={faFlag} size="4x" />
                </Col>
                <Col class="text-end">
                  <p class="h4">{obj.solved}/{obj.total}</p>
                  {obj.category}
                </Col>
              </Row>
            </CardBody>
          </Card>
        </div>
      {/each}
    </div>
  {:else}
    <p>Waiting for CTF challenges to be released!</p>
  {/if}
</div>
